<?php

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2011 Marc Steiner, Tobias Blaser, Willi Kernen, <contact@gridds.com>, GRiDDS GmbH
 *  
 *  idea from freshman17 (typo3.net)
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * TS Setup loader
 *
 * @package grds_language_menu
 * @license http://www.gnu.org/licenses/lgpl.html GNU Lesser General Public License, version 3 or later
 */
class Tx_GrdsLanguageMenu_Service_TsSettings {
 
	/**
	 * get TS setup
	 * Return for $_EXTKEY the plugin-array without dots
	 * 
	 * @param string $_EXTKEY Extension-Key (f.e. 'tx_extbase')
	 * @param boolean $plugin (true für plugin TS, false für config TS)
	 * @return	array
	 */
	public static function getTsSetup($_EXTKEY, $plugin = true) {		
		// load TS of $_EXTKEY
		$settings = t3lib_div::makeInstance('Tx_Extbase_Configuration_FrontendConfigurationManager')->getTypoScriptSetup();
		$tsSettings = self::removeDots($settings[$plugin ? 'plugin.' : 'config.'][$_EXTKEY.'.']);
		return $tsSettings['settings'];
	}
 
	/**
	 * remove dots
	 * remove dots in the ts array
	 * 
	 * @return void
	 */
	private static function removeDots($settings) {
		$conf = array();
		foreach ($settings as $key => $value)
			$conf[self::removeDotAtTheEnd($key)] = is_array($value) ? self::removeDots($value) : $value;
		return $conf;
	}
 
	/**
	 * remove dots at the end of the string
	 * 
	 * @param string $string
	 * @return string $string
	 */
	private static function removeDotAtTheEnd($string) {
		return preg_replace('/\.$/', '', $string);
	} 
}
?>